# include <iostream>
# include <vector>
# include <tuple>
using namespace std;

const long long MAX=1e5+1;
string a[MAX];
long long n;

pair<long long, vector<long long>> solve(long long l, long long r, long long id)
{
    if(l==r) return {0,{1}};

    vector<long long> k;
    long long nl=l;
    char c;
    if(a[l].size()-1<id) c='#';
    else c=a[l][id];

    long long curr=0;
    for(long long i=l; i<=r; i++)
    {
        if(a[i].size()-1<id or a[i][id]!=c)
        {
            if(i-nl!=1 and c!='#')
            {
                //curr+=max((i-nl)*(id+1),solve(nl,i-1,id+1));
                auto sol=solve(nl,i-1,id+1);
                if((i-nl)*(id+1)>=sol.first)
                {
                    curr+=(i-nl)*(id+1);
                    k.push_back(i-nl);
                }
                else
                {
                    curr+=sol.first;
                    for(auto x:sol.second) k.push_back(x);
                }
            }
            else if(c!='#') k.push_back(1);

            nl=i;
            if(a[i].size()-1<id) c='#';
            else c=a[i][id];
        }
    }

    if(r+1-nl!=1 and c!='#')
    {
        auto sol=solve(nl,r,id+1);
        if((r+1-nl)*(id+1)>=sol.first)
        {
            curr+=(r+1-nl)*(id+1);
            k.push_back(r+1-nl);
        }
        else
        {
            curr+=sol.first;
            for(auto x:sol.second) k.push_back(x);
        }
    }
    else if(c!='#') k.push_back(1);

    //cout<<l<<" "<<r<<" "<<id<<":"<<curr<<endl;
    return {curr,k};
}

//imat pone 1 obsto

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n;
    for(long long i=1; i<=n; i++)
    {
        cin>>a[i];
    }

    auto ans=solve(1,n,0);
    cout<<ans.first<<" "<<ans.second.size()<<endl;
    for(auto x: ans.second) cout<<x<<" ";
    cout<<endl;
    return 0;
}
