#include <bits/stdc++.h>
using namespace std;
const int MAXN = 100007;
int lcp[MAXN];
bool used[MAXN];
set<int> lcps;
int getLcp(const string& a, const string& b){
    int i;
    for(i = 0; i < a.size() && i < b.size(); i++){
        if(a[i] != b[i]){
            break;
        }
    }
    lcps.insert(i);
    return i;
}
int main(){
    int n;
    cin >> n;
    vector<string> t(n);
    for(int i = 0; i < n; i++){
        cin >> t[i];
    }

    for(int i = 0; i < n-1; i++){
        lcp[i] = getLcp(t[i], t[i+1]);
    }

    int sum = 0;
    vector<pair<int, int>> groups;
    for(set<int>::reverse_iterator it = lcps.rbegin(); it != lcps.rend(); ++it){
        int p = *it;
//        cout << "p: " << p << '\n';
        int grpSz = 0, grpSt = -1;
        for(int i = 0; i < n; i++){
            if(lcp[i] == p){
                if(!used[i+1]){
                    used[i+1] = true;
                    grpSz++;
                    grpSt = i+1;
                }
                if(!used[i]){
                    used[i] = true;
                    grpSz++;
                    grpSt = i;
                }
            }else{
//                cout << '\t' << grpSz << '\n';
                if(grpSz >= 1){ groups.push_back({grpSt, grpSz}); }
                if(grpSz >= 2){ sum += grpSz*p; }
                grpSz = 0;
            }
        }
    }
    sort(groups.begin(), groups.end());
    cout << sum << ' ' << groups.size() << '\n';
    for(int i = 0; i < groups.size(); i++){
        cout << groups[i].second;
        if(i+1 < groups.size()){ cout << ' '; }
    }
    cout << '\n';
    return 0;
}
