#include <bits/stdc++.h>
using namespace std;
const int MAXN = 507;
int locToPlayer[MAXN];
vector<vector<pair<int, int>>> G;
bool vis[MAXN];
int n;
int start;

int mnDiff;
vector<int> mnHist;
bool cycle_dfs(int curr, vector<int> hist, int sum){
    if(vis[curr]){
        if(sum < mnDiff){
            mnDiff = sum;
            mnHist = hist;
        }
        return true;
    }
    vis[curr] = true;
    hist.push_back(curr);
    for(int i = 0; i < G[curr].size(); i++){
        int next = G[curr][i].first;
        if(next == start || !vis[next]){
            int nxtSum = sum + G[curr][i].second;
            if(cycle_dfs(next, hist, nxtSum)){
                return true;
            }
        }
    }
    return false;
}
bool checkCycles(const vector<int>& k){
    mnDiff = INT_MAX;
    mnHist = {};
    bool found = false;
    for(int i = 1; i <= n; i++){
        memset(vis, 0, n+1);
        start = i;
        found |= cycle_dfs(i, {}, 0);
    }
    if(found){
        cout << "YES " << mnDiff << '\n';
        int sz = mnHist.size();
        mnHist.push_back(mnHist[0]);
        vector<int> k2 = k;
        for(int i = 0; i < sz; i++){
            int to = mnHist[i];
            int from = mnHist[i+1];
            k2[to] = k[from];
        }
        for(int i = 1; i <= n; i++){
            cout << k2[i];
            if(i < n){ cout << ' '; }
        }cout << '\n';
        return true;
    }

    return false;
}
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    cin >> n;
    G.resize(n+1);
    vector<int> k(n+1);
    vector<vector<int>> p(n+1);
    for(int i = 1; i <= n; i++){
        cin >> k[i];
        locToPlayer[k[i]] = i;
    }

    for(int i = 1; i <= n; i++){
        p[i].resize(n);
        for(int j = 0; j < n; j++){
            cin >> p[i][j];
        }
    }

    /// YES <=> grafa ima cycli
    for(int i = 1; i <= n; i++){
        int own;
        for(own = 0; own < n && p[i][own] != k[i]; own++){}
        for(int j = own-1; j >= 0; j--){
            G[i].push_back({locToPlayer[p[i][j]], own-j});
//            cout << i << " -> " << locToPlayer[p[i][j]] << ' ' << own-j << '\n';
            if(checkCycles(k)){ return 0; }
        }
    }

    cout << "NO\n";

    return 0;
}
