#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

vector<int> groups[30];

int digits[10];

void f(int pos, int sum)
{
    if (pos == 9)
    {
        int num = 0;
        int s = 0;

        for (int i = 1; i <= 8; ++i)
        {
            num = num * 10 + digits[i];
            s += digits[i];
        }

        if (num % s == 0)
        {
            groups[s].push_back(num);
        }

        return;
    }

    for (int d = 0; d <= min(9, sum); ++d)
    {
        digits[pos] = d;
        f(pos + 1, sum - d);
    }
}

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    /*int x = 0;
    int sum = 0;

    for (int i = 1; i <= 10000000; ++i)
    {
        x = i;
        sum = 0;

        while (x != 0)
        {
            sum += (x % 10);
            x /= 10;
        }

        if (sum > 26)
        {
            continue;
        }

        if (i % sum == 0)
        {
            groups[sum].push_back(i);
        }
    }*/

    f(1, 26);

    for (int i = 1; i <= 26; ++i)
    {
        sort(groups[i].begin(), groups[i].end());
    }

    int q;
    cin >> q;

    while (q--)
    {
        int l, r, d;
        cin >> l >> r >> d;

        cout << (upper_bound(groups[d].begin(), groups[d].end(), r) - lower_bound(groups[d].begin(), groups[d].end(), l)) << "\n";
    }

    return 0;
}
