#include <bits/stdc++.h>
using namespace std;

const int MAXN=5001;
int N;
int K[MAXN];
int perm[MAXN][MAXN];
int k[MAXN];
int ir[MAXN][MAXN];
int dist[MAXN];
int ans=1e9;
vector<pair<int, int>> edges[MAXN];

void fastIO()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void read()
{
    cin >> N;

    for(int i=0; i<N; i++)
    {
        cin >> K[i];
        k[K[i]]=i;
    }

    for(int i=0; i<N; i++)
    {
        for(int j=0; j<N; j++)
        {
            cin >> perm[i][j];
            ir[i][perm[i][j]]=j;
        }
    }
}

void build_edges()
{
    for(int i=0; i<N; i++)
    {
        for(int j=0; j<N; j++)
        {
            if(perm[i][j]==K[i])
            {
                break;
            }

            ///cout << "build edge from " << i << " to " << k[perm[i][j]] << " weight " << ir[i][K[i]]-j << '\n';
            int w=ir[i][K[i]]-j;
            edges[i].push_back({k[perm[i][j]], ir[i][K[i]]-j});
        }
    }
}

void dfs(int u, int start, int curr)
{
    if(u==start && curr>0)
    {
        ///cout << start << " " << curr << '\n';
        ans=min(ans, curr);
        return;
    }

    if(dist[u]<curr)
    {
        return;
    }

    dist[u]=curr;

    for(auto& v:edges[u])
    {
        ///cout << start << " " << v.first << " " << v.second << " " << curr << '\n';
        dfs(v.first, start, curr+v.second);
    }
}

void solve()
{
    for(int i=0; i<N; i++)
    {
        for(int i=0; i<N; i++)
        {
            dist[i]=1e9;
        }

        dfs(i, i, 0);
    }

    if(ans==1e9)
    {
        cout << "NO";
    }
    else
    {
        cout << "YES" << " " << ans << '\n';

        for(int i=0; i<N; i++)
        {
            cout << 0 << " ";
        }
    }
}

int main()
{
    fastIO();
    read();
    build_edges();
    solve();
    return 0;
}

/*
3
1 2 3
3 2 1
3 1 2
1 2 3
*/

