#include <bits/stdc++.h>
using namespace std;

const int MAXT=1e5+1, MAXD=27;
int T;
int maxR=0;
tuple<int, int, int> questions[MAXT];
vector<int> answers[MAXD];
set<int> divs;

void fastIO()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void read()
{
    cin >> T;

    for(int i=0; i<T; i++)
    {
        cin >> get<0>(questions[i]) >> get<1>(questions[i]) >> get<2>(questions[i]);
        maxR=max(maxR, get<1>(questions[i]));
        divs.insert(get<2>(questions[i]));
    }
}

bool check(int x, int D)
{
    int sum=0;

    while(x!=0)
    {
        sum+=x%10;
        x/=10;

        if(sum>D)
        {
            return false;
        }
    }

    if(sum==D)
    {
        return true;
    }

    return false;
}

void generate_answers()
{
    for(auto& D:divs)
    {
        if(D==1)
        {
            for(int x=1; x<=maxR; x*=10)
            {
                answers[D].push_back(x);
            }
        }
        else
        {
            for(int x=D; x<=maxR; x+=D)
            {
                if(check(x, D))
                {
                    answers[D].push_back(x);
                }
            }
        }
    }
}

void bin(int i)
{
    int l=0, r=answers[get<2>(questions[i])].size()-1;
    int borderL=-1;

    while(l<=r)
    {
        int m=(l+r)/2;

        if(get<0>(questions[i])<=answers[get<2>(questions[i])][m])
        {
            borderL=m;
            r=m-1;
        }
        else
        {
            l=m+1;
        }
    }

    l=0;
    r=answers[get<2>(questions[i])].size()-1;
    int borderR=-1;

    while(l<=r)
    {
        int m=(l+r)/2;

        if(get<1>(questions[i])>=answers[get<2>(questions[i])][m])
        {
            borderR=m;
            l=m+1;
        }
        else
        {
            r=m-1;
        }
    }

    if(borderR==-1 || borderL==-1)
    {
        cout << 0 << '\n';
    }
    else
    {
        cout << borderR-borderL+1 << '\n';
    }
}

void solve()
{
    for(int i=0; i<T; i++)
    {
        bin(i);
    }
}


int main()
{
    fastIO();
    read();
    generate_answers();
    solve();
    return 0;
}
