#include <bits/stdc++.h>
#define endl "\n"

using namespace std;

struct edge
{
    int ver,dist;
    edge(){};
    edge(int vi, int di)
    {
        ver = vi;
        dist = di;
    }
};

const int maxn = 501;
int n,k[maxn],pos[maxn];
int a[maxn][maxn],idx[maxn][maxn];
int ans[maxn],mins = 1e9;
int used[maxn],vis[maxn],dep[maxn],p[maxn];
int ch1,ch2;
vector<edge>g[maxn];

void read()
{
    cin >> n;
    for(int i=1;i<=n;i++)
    {
        cin >> k[i];
        pos[k[i]] = i;
    }
    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=n;j++)
        {
            cin >> a[i][j];
            idx[i][a[i][j]] = j;
            if(a[i][j]!=k[i]) continue;
            for(int j2=j-1;j2>=max(1,j-100);j2--)
            {
                g[i].push_back({pos[a[i][j2]],j-j2});
                //cout << i << "->" << pos[a[i][j2]] << endl;
            }
        }
    }
}

void dfs(int beg, int par, int sum)
{
    used[beg] = 1;
    vis[beg] = 1;
    dep[beg] = sum;
    p[beg] = par;
    for(edge nb : g[beg])
    {
        if(!used[nb.ver]) dfs(nb.ver,beg,sum+nb.dist);
        else if(used[nb.ver]==1)
        {
            if(dep[beg]-dep[nb.ver]+nb.dist<mins)
            {
                mins = dep[beg]-dep[nb.ver]+nb.dist;
                ch1 = beg;
                ch2 = nb.ver;
            }
        }
    }
    used[beg] = 2;
}

void rec(int beg)
{
    if(beg==ch2)
    {
        ans[ch1] = k[beg];
        return;
    }
    ans[p[beg]] = k[beg];
    rec(p[beg]);
}

void solve()
{
    for(int i=1;i<=n;i++)
    {
        if(!vis[i]) dfs(i,i,0);
    }
    if(mins==1e9) cout << "NO" << endl;
    else
    {
        cout << "YES" << " " << mins << endl;
        /*rec(ch1);
        for(int i=1;i<=n;i++)
        {
            if(!ans[i]) cout << k[i] << " ";
            else cout << ans[i] << " ";
        }
        cout << endl;*/
        for(int i=1;i<=n;i++) cout << 0 << " ";
        cout << endl;
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    read();
    solve();
    return 0;
}
