#include <bits/stdc++.h>

using namespace std;

const int maxn = 501;
long long n, dp[maxn], b[maxn];
int mat[maxn][maxn];
string s[maxn];

void read(){
    cin >> n;
    for(int i = 1;i <= n;i++){
        cin >> s[i];
    }
    for(int i = 1;i <= n;i++){
        string e = s[i];
        for(int j = i + 1;j <= n;j++){
            string ne = "";
            for(int k = 0;k < min(e.size(), s[j].size());k++){
                if(e[k] == s[j][k]){
                    ne += e[k];
                }
                else{
                    break;
                }
            }
            mat[i][j] = ne.size();
            e = ne;
        }
    }
}

vector<int> group;

void backtrack(int n){
    if(n == 0)
        return;
    backtrack(b[n]);
    group.push_back(n - b[n]);
}

void solve(){
    for(int i = 1;i <= n;i++){
        dp[i] = dp[i - 1];
        b[i] = i - 1;
        for(int j = 0;j < i - 1;j++){
            if(dp[i] < dp[j] + (i - j) * mat[j + 1][i]){
                dp[i] = dp[j] + (i - j) * mat[j + 1][i];
                b[i] = j;
            }
        }

    }
    backtrack(n);
    cout << dp[n] << " " << group.size() << endl;
    for(int x : group){
        cout << x << " ";
    }
    cout << endl;
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    read();
    solve();
    return 0;
}
