#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int maxn = 1e5 + 10;
long long n, dp[maxn], b[maxn];
int mat[maxn];
string s[maxn];

void read(){
    cin >> n;
    for(int i = 1;i <= n;i++){
        cin >> s[i];
    }
    for(int i = 2;i <= n;i++){
        int cnt = min(s[i].size(), s[i - 1].size()), br = 0;
        for(int k = 0;k < cnt;k++){
            if(s[i][k] == s[i - 1][k]){
                br++;
            }
            else{
                break;
            }
        }
        mat[i] = br;
    }
}

vector<int> group;

void backtrack(int n){
    if(n == 0)
        return;
    backtrack(b[n]);
    group.push_back(n - b[n]);
}

void solve(){
    int cnt = 2;
    for(int i = 2;i <= n;i++){
        if(mat[i] == mat[i - 1])
            cnt++;
        else
            cnt = 2;
        dp[i] = dp[i - 1];
        b[i] = i - 1;
        if(dp[i] < dp[i - cnt] + cnt * mat[i]){
            dp[i] = dp[i - cnt] + cnt * mat[i];
            b[i] = i - cnt;
        }
        if(cnt > 2){
            cnt--;
            if(dp[i] < dp[i - cnt] + cnt * mat[i]){
                dp[i] = dp[i - cnt] + cnt * mat[i];
                b[i] = i - cnt;
            }
            cnt++;
        }
        if(cnt > 3){
            cnt -= 2;
            if(dp[i] < dp[i - cnt] + cnt * mat[i]){
                dp[i] = dp[i - cnt] + cnt * mat[i];
                b[i] = i - cnt;
            }
            cnt += 2;
        }
    }
    backtrack(n);
    cout << dp[n] << " " << group.size() << endl;
    for(int x : group){
        cout << x << " ";
    }
    cout << endl;
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    read();
    solve();
    return 0;
}
