#include <bits/stdc++.h>

using namespace std;

const int maxn = 505;

int n;

int p[maxn];

int a[maxn][maxn];

vector<pair<int, int>> numbers[maxn];

bool seen[maxn];

int f(int id, vector<int>& curr)
{
    if (id == n + 1)
    {
        for (int i = 0; i < curr.size(); ++i)
        {
            if (curr[i] != i + 1)
            {
                return 0;
            }
        }

        return 1e9;
    }

    int res = 1e9;

    for (int i = 0; i < numbers[id].size(); ++i)
    {
        if (seen[numbers[id][i].first] == false)
        {
            seen[numbers[id][i].first] = true;
            curr.push_back(numbers[id][i].first);

            res = min(res, numbers[id][i].second + f(id + 1, curr));

            seen[numbers[id][i].first] = false;
            curr.pop_back();
        }
    }

    return res;
}

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    cin >> n;

    for (int i = 1; i <= n; ++i)
    {
        cin >> p[i];
    }

    for (int i = 1; i <= n; ++i)
    {
        for (int j = 1; j <= n; ++j)
        {
            cin >> a[i][j];
        }
    }

    for (int i = 1; i <= n; ++i)
    {
        for (int j = 1; j <= n; ++j)
        {
            if (a[i][j] == p[i])
            {
                numbers[i].push_back(make_pair(a[i][j], 0));

                if (j > 1)
                {
                    numbers[i].push_back(make_pair(a[i][j - 1], 1));
                }
            }
        }
    }

    vector<int> curr;

    int ans = f(1, curr);

    if (ans <= 1e9)
    {
        cout << "YES " << ans << endl;

        for (int i = 0; i < n; ++i)
        {
            cout << 0 << ' ';
        }

        cout << endl;
    }
    else
    {
        cout << "NO" << endl;
    }

    return 0;
}
/*
5
5 4 3 2 1
4 3 2 1 5
4 2 5 1 3
3 1 4 5 2
5 4 3 1 2
2 3 1 5 4
*/
