#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

vector<int> groups[30];

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    int x = 0;
    int sum = 0;

    for (int i = 1; i <= 100000000; ++i)
    {
        if (i % 10 - (i - 1) % 10 == 1 && sum > 26)
        {
            continue;
        }

        x = i;
        sum = 0;

        while (x != 0)
        {
            sum += (x % 10);
            x /= 10;
        }

        if (sum > 26)
        {
            continue;
        }

        if (i % sum == 0)
        {
            groups[sum].push_back(i);
        }
    }

    int q;
    cin >> q;

    while (q--)
    {
        int l, r, d;
        cin >> l >> r >> d;

        cout << (upper_bound(groups[d].begin(), groups[d].end(), r) - lower_bound(groups[d].begin(), groups[d].end(), l)) << "\n";
    }

    return 0;
}
