#include <bits/stdc++.h>
using namespace std;

const int MAXN=501;
int N;
int K[MAXN];
int perm[MAXN][MAXN];
int key[MAXN];
int index[MAXN][MAXN];
int visited[MAXN], visited_count;
int ans=1e9;
vector<pair<int, int>> edges[MAXN];

void fastIO()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void read()
{
    cin >> N;

    for(int i=0; i<N; i++)
    {
        cin >> K[i];
        key[K[i]]=i;
    }

    for(int i=0; i<N; i++)
    {
        for(int j=0; j<N; j++)
        {
            cin >> perm[i][j];
            index[i][perm[i][j]]=j;
        }
    }
}

void build_edges()
{
    for(int i=0; i<N; i++)
    {
        for(int j=0; j<N; j++)
        {
            if(perm[i][j]==K[i])
            {
                break;
            }

            ///cout << "build edge from " << i << " to " << key[perm[i][j]] << " weight " << index[i][K[i]]-j << '\n';
            edges[i].push_back({key[perm[i][j]], index[i][K[i]]-j});
        }
    }
}

void dfs(int u, int start, int curr)
{
    if(visited[u]==visited_count)
    {
        if(u==start)
        {
            ///cout << start << " " << curr << '\n';
            ans=min(ans, curr);
        }

        return;
    }

    visited[u]=visited_count;

    for(auto& v:edges[u])
    {
        dfs(v.first, start, curr+v.second);
    }
}

void solve()
{
    for(int i=0; i<N; i++)
    {
        visited_count++;
        dfs(i, i, 0);
    }

    if(ans==1e9)
    {
        cout << "NO";
    }
    else
    {
        cout << "YES" << " " << ans << '\n';

        for(int i=0; i<N; i++)
        {
            cout << 0 << " ";
        }
    }
}

int main()
{
    fastIO();
    read();
    build_edges();
    solve();
    return 0;
}

