#include <bits/stdc++.h>
using namespace std;

const int MAXN=5001;
int N;
int K[MAXN];
int perm[MAXN][MAXN];
int k[MAXN];
int ir[MAXN][MAXN];
int dist[MAXN];
int ans=1e9;
vector<int> swaps;
vector<pair<int, int>> edges[MAXN];

void fastIO()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void read()
{
    cin >> N;

    for(int i=0; i<N; i++)
    {
        cin >> K[i];
        k[K[i]]=i;
    }

    for(int i=0; i<N; i++)
    {
        for(int j=0; j<N; j++)
        {
            cin >> perm[i][j];
            ir[i][perm[i][j]]=j;
        }
    }
}

void build_edges()
{
    if(N<500)
    {
        for(int i=0; i<N; i++)
        {
            for(int j=0; j<N; j++)
            {
                if(perm[i][j]==K[i])
                {
                    break;
                }

                ///cout << "build edge from " << i << " to " << k[perm[i][j]] << " weight " << ir[i][K[i]]-j << '\n';
                int w=ir[i][K[i]]-j;
                edges[i].push_back({k[perm[i][j]], ir[i][K[i]]-j});
            }
        }
    }
    else
    {
        for(int i=0; i<N; i++)
        {
            for(int j=ir[i][K[i]]-1; j<ir[i][K[i]]; j++)
            {
                if(perm[i][j]==K[i])
                {
                    break;
                }

                ///cout << "build edge from " << i << " to " << k[perm[i][j]] << " weight " << ir[i][K[i]]-j << '\n';
                int w=ir[i][K[i]]-j;
                edges[i].push_back({k[perm[i][j]], ir[i][K[i]]-j});
            }
        }
    }
}

void dfs(int u, int start, int curr, vector<int> vect)
{
    if(u==start && curr>0)
    {
        ///cout << start << " " << curr << '\n';
        if(curr<ans)
        {
            ans=curr;
            swaps=vect;
        }
        return;
    }

    if(dist[u]<curr)
    {
        return;
    }

    dist[u]=curr;

    for(auto& v:edges[u])
    {
        vect.push_back(v.first);
        dfs(v.first, start, curr+v.second, vect);
        vect.pop_back();
    }
}

void solve()
{
    for(int i=0; i<N; i++)
    {
        for(int i=0; i<N; i++)
        {
            dist[i]=1e9;
        }

        vector<int> vect;
        vect.push_back(i);

        dfs(i, i, 0, vect);
    }

    if(ans==1e9)
    {
        cout << "NO";
    }
    else
    {
        cout << "YES" << " " << ans << '\n';

        for(int i=1; i<swaps.size()-1; i++)
        {
            swap(K[swaps[i]], K[swaps[i-1]]);
        }

        for(int i=0; i<N; i++)
        {
            cout << K[i] << " ";
        }
    }
}

int main()
{
    fastIO();
    read();
    build_edges();
    solve();
    return 0;
}

/*
3
1 2 3
3 2 1
3 1 2
1 2 3
*/
