#include <bits/stdc++.h>
using namespace std;

const int MAXT=1e5+1, MAXD=27;
int T;
int maxR=0;
tuple<int, int, int> questions[MAXT];
vector<int> answers[MAXD];

void fastIO()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void read()
{
    cin >> T;

    for(int i=0; i<T; i++)
    {
        cin >> get<0>(questions[i]) >> get<1>(questions[i]) >> get<2>(questions[i]);
        maxR=max(maxR, get<1>(questions[i]));
    }
}

bool check(int x, int D)
{
    int sum=0;

    while(x!=0)
    {
        sum+=x%10;
        x/=10;

        if(sum>D)
        {
            return false;
        }
    }

    if(sum==D)
    {
        return true;
    }

    return false;
}

void generate_answers()
{
    for(int D=1; D<=26; D++)
    {
        for(int x=D; x<=maxR; x+=D)
        {
            if(check(x, D))
            {
                answers[D].push_back(x);
            }
        }
    }
}

void solve()
{
    for(int i=0; i<T; i++)
    {
        int ans=0;

        for(auto& x:answers[get<2>(questions[i])])
        {
            if(x>get<1>(questions[i]))
            {
                break;
            }

            if(x>=get<0>(questions[i]))
            {
                ans++;
            }
        }

        cout << ans << '\n';
    }
}


int main()
{
    fastIO();
    read();
    generate_answers();
    solve();
    return 0;
}
