#include <bits/stdc++.h>

using namespace std;

const int maxn = 1e6 + 10;
int n, dp[maxn], b[maxn];
string s[maxn];

void read(){
    cin >> n;
    for(int i = 1;i <= n;i++){
        cin >> s[i];
    }
}

map<string, int> prefix, nprefix;
vector<int> group;

void backtrack(int n){
    if(n == 0)
        return;
    backtrack(b[n]);
    group.push_back(n - b[n]);
}

void solve(){
    string t = "";
    for(char x : s[1]){
        t += x;
        prefix[t] = 1;
    }
    for(int i = 2;i <= n;i++){
        string t = "";
        dp[i] = dp[i - 1];
        b[i] = i - 1;
        for(char x : s[i]){
            t += x;
            int c = prefix[t] + 1;
            if(c == 1)
                break;
            int p = c;
            if(c == 1)
                p = 0;
            for(int j = i - c;j < i - 1;j++)
                if(dp[i] < dp[j] + (i - j) * t.size()){
                    dp[i] = dp[j] + (i - j) * t.size();
                    b[i] = j;
                }
            nprefix[t] = c;
        }
        prefix = nprefix;
        nprefix.clear();
    }
    backtrack(n);
    cout << dp[n] << " " << group.size() << endl;
    for(int x : group){
        cout << x << " ";
    }
    cout << endl;
}
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    read();
    solve();
    return 0;
}
