#include <bits/stdc++.h>

using namespace std;

const int maxn = 1e6 + 10;
int n, dp[maxn], b[maxn], a[maxn];
string s[maxn];

void read(){
    cin >> n;
    for(int i = 1;i <= n;i++){
        cin >> s[i];
    }
}

map<string, int> prefix, nprefix;
vector<int> group;

void backtrack(int n){
    if(n == 0)
        return;
    backtrack(b[n]);
    group.push_back(n - b[n]);
}

void solve(){
    string t = "";
    for(char x : s[1]){
        t += x;
        prefix[t] = 1;
    }
    for(int i = 2;i <= n;i++){
        string t = "";
        for(char x : s[i]){
            t += x;
            int c = prefix[t] + 1;
            nprefix[t] = 1;
            if(c != 1)
                a[i] = t.size();
        }
        prefix = nprefix;
        nprefix.clear();
    }
    for(int i = 2;i <= n - 1;i++){
        if(a[i] == a[i + 1])
            a[i] = -1;
        while(i <= n - 1 && a[i] == a[i + 1])
            i++;
    }
    int cnt = 2;
    for(int i = 2;i <= n;i++){
        if(a[i] == a[i - 1])
            cnt++;
        if(a[i] != a[i - 1])
            cnt = 2;
        b[i] = i - 1;
        dp[i] = dp[i - 1];
        if(dp[i] < dp[i - cnt] + a[i] * cnt){
            dp[i] = dp[i - cnt] + cnt * a[i];
            b[i] = i - cnt;
        }

    }
    backtrack(n);
    cout << dp[n] << " " << group.size() << endl;
    for(int x : group){
        cout << x << " ";
    }
    cout << endl;
}
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    read();
    solve();
    return 0;
}
