#include <bits/stdc++.h>

using namespace std;

const int maxn = 27;
vector<int> v[maxn];

void rec(int d, int ch, int sum){
    if(ch > 1e7)
        return;
    int num = 0;
    if(ch == 0)
        num = 1;
    if(sum == d){
        if(ch % d == 0)
            v[d].push_back(ch);
    }
    for(int i = num;i <= 9;i++){
        if(sum + i <= d){
            rec(d, ch * 10 + i, sum + i);
        }
        else break;
    }
}
void preCompute(){
    for(int i = 1;i <= 26;i++){
        rec(i, 0, 0);
    }

    for(int i = 1;i <= 26;i++)
        sort(v[i].begin(), v[i].end());
}

void query(int l, int r, int d){
    int x = 0, y = v[d].size() - 1, ans1 = 0;
    while(x <= y){
        int mid = (x + y) / 2;
        if(v[d][mid] < l)
            x = mid + 1, ans1 = mid + 1;
        else
            y = mid - 1;
    }
    int z = 0, t = v[d].size() - 1, ans2 = 0;
    while(z <= t){
        int mid = (z + t) / 2;
        if(v[d][mid] <= r)
            z = mid + 1, ans2 = mid + 1;
        else
            t = mid - 1;
    }
    cout << ans2 - ans1 << endl;
}
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    preCompute();
    int t;
    cin >> t;
    while(t--){
        int l, r, d;
        cin >> l >> r >> d;
        query(l, r, d);
    }
    return 0;
}
