#include <bits/stdc++.h>

using namespace std;

const int maxn = 27;
int s[(int)1e7];
vector<int> v[maxn];

int sum(int x){
    int s = 0;
    do{
        s += x % 10;
        x /= 10;
    }while(x);
    return s;
}

void preCompute(){
    for(int i = 1;i < 1e7;i++)
        s[i] = sum(i);
    for(int i = 1;i <= 26;i++){
        for(int j = i;j < 1e7;j += i){
            if(s[j] == i)
                v[i].push_back(j);
        }
    }
}

void query(int l, int r, int d){
    int x = 0, y = v[d].size() - 1, ans1 = 0;
    while(x <= y){
        int mid = (x + y) / 2;
        if(v[d][mid] < l)
            x = mid + 1, ans1 = mid + 1;
        else
            y = mid - 1;
    }
    int z = 0, t = v[d].size() - 1, ans2 = 0;
    while(z <= t){
        int mid = (z + t) / 2;
        if(v[d][mid] <= r)
            z = mid + 1, ans2 = mid + 1;
        else
            t = mid - 1;
    }
    cout << ans2 - ans1 << endl;
}
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    preCompute();
    int t;
    cin >> t;
    while(t--){
        int l, r, d;
        cin >> l >> r >> d;
        query(l, r, d);
    }
    return 0;
}
